;s0	r0  A				
;s1	r1  B BC 
;s2 ,vr2  D DE
;s3 r3  H HL
;s4	,vr4  C
;s5	r5  E
;s6 ,vr6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)

vm_remap_TableAddr equ vm_rambaseAddr+0xFFF0



	.include "Header.asm"


	.include "\SrcAll\BasicMacros.asm"
  
  
	.include "\srcALL\ChibiVm_InstSet.asm"
	
 
	
VM_ProgLoadAddr equ 0x400	

	
	
	; la a0,vm_rambaseAddr		;Address
	; lw a0,(a0)
	
	
	
	; li s0,0x0200				;Stack
	; StoreLEA0 s0,vm_rsp
	
	; li s0,0x0000
	; StoreLEA0 s0,vm_rBank0
	; li s0,0x4000
	; StoreLEA0 s0,vm_rBank1
	; li s0,0x8000
	; StoreLEA0 s0,vm_rBank2
	; li s0,0xC000
	; StoreLEA0 s0,vm_rBank3
	
;Copy our program to VM Ram
	; la a0,vm_rambaseAddr		;Address
	; lw s2,(a0)
	; lw a0,(a0)
	
	; la s3,VM_Program_Zero
	; li s1,VM_Program_End-VM_Program_Zero
	
	
	
; ProgramCopyAgain2:	
	; lbu s0,(s3)
	; addi s3,s3,1
	; sb s0,(s2)
	; addi s2,s2,1
	
	; addi s1,s1,-1
	; bne s1,zero,ProgramCopyAgain2
	; nop 
	
	
	;li s0,0x0800				;Prog Start
	;StoreLEA0 s0,vm_rpc
	
	jal ChibiVM_Init
	nop
	
	
	li s1,100
ProgSkip:
	;jal VM_Tick
	; nop
	
	; addi s1,s1,-1
	; bne s1,zero,ProgSkip
	; nop
	
InfLoop:
	jal VM_Tick
	nop
		

	j InfLoop					;Halt
	nop

;Debugger
	


	li s2,0	;Xpos
	li s5,0	;Ypos

	la a2,vm_rambaseAddr	;Address
	lw a2,(a2)
	li a1,6	;Lines
	
	;jal Monitor
	;nop
	
	jal MemDump				;Dump to screen
	nop
	
	
	
	la a0,vm_rambaseAddr	;Address
	lw a2,(a0)
	nop
	addi a2,a2,0x0200		;Stack
	addi a2,a2,-12

	li a1,2				;Lines
	jal MemDump				;Dump to screen
	nop
	
	la a0,vm_rambaseAddr		;Address
	lw a2,(a0)
	lw a0,(a0)
	LoadLEA0 vm_rpc,a2
	li a1,3				;Lines
	jal MemDump				;Dump to screen
	nop
	
	
	;jal Monitor
	;nop
	
	jal VM_Tick
	nop
	
	;jal ReadJoystick
	;nop
	;li s2,0
	;li s5,10
	;jal Monitor			;Reg Dump
	;nop
	
	
	jal WaitForFire
	nop


   j InfLoop					;Halt
	nop
vm_rambaseAddr: .dw ramarea+65536


;vm_syscalls:
	;.dw VM_Program
	;.dw TestSysCall1
	
TestSysCall1:
	li s0,0xE4
	la a0,vm_rambaseAddr
	lw a0,(a0)
	nop
	sb s0,VM_rR1(a0)
	
	
	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
vm_trap_TableAddr: .dw  ramarea+65536+0x0A46


	
	
	.include "\srcALL\ChibiVm_CPU.asm"
	;.include "\srcALL\test.asm"
;vm_trap_tableaddr: .dw 0
;vm_syscalls:	.dw 0
	
;vm_rambaseaddr:	.dw ramarea+0x10000	

	.include "ChibiVM_AdventureEngine.asm"
	
	
	
	.include "ChibiVM_Host.asm"
	.align 4	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	.include "core.asm"
	.include "monitor.asm"  	

; .macro advcall,p1
	; .db p1
	; .db p1/256
; .endmacro 	

	.align 65536
VM_Program_Zero:
	.fill 0x400		
VM_Program:	
	.db "!!!!Chibi/VM!!!!"			;Magic key - must be on a $xxxxxx00 boundary
	.db "Your product name here          "		;Software Name - 32 bytes

	;rorg $10000+VM_ProgLoadAddr+$30
	.db 0			;Header Version
	.db 0b00000011	; config {COpy Vectors to $100}
	.db 0b00111111	;Requirements {adv} {reikou} {maxtile} {QTV} {NS} {memmapper} {ChibiTracks}
	.db 0			;Spare
	.db 0			;Spare
	.db 0			;Cpu Requirements
	.db 0			;Ram Requirements
	.db 0 			;Vector Requorements {Vblank}
	.db 0 			;SysCall Requirements {VmMonitor}{VmControl}{ChipExt}
	.db 0 			;SysCall Requirements
	.db 0			;ChipExt Requirements ???
	.db 0			;ChipExt Requirements ???
	.db 0x11		;Bitmap Modes 0-7 {NS / Maxtile} 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.db 0x01		;Bitmap Modes 0-7 {AdvFont / QTV } 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.db 0			;Bitmap modes (spare)
	.db 0			;Bitmap modes (spare)
	
	;rorg $10000+VM_ProgLoadAddr+$40
	dl 0x400		;Rom Load Address
	dl 0x200		;StackPointer
	dl 0x100		;Trap table Ram address (0=none)
	dl 0x0000		;Memmap 1
	dl 0x4000		;Memmap 2
	dl 0x8000		;Memmap 3
	dl 0xC000		;Memmap 4

	.db 0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	;rorg $10000+VM_ProgLoadAddr+$70
	dl (vm_traps-VM_Program)	;Vector table (0=none)
	dl 0x2000		;Address remap table (0=none)
	dl 0			;VMAssets (Palette,Font etc)
	dl 0			;???

VM_Program_Hend:

	.fill 0x800	-(VM_Program_Hend-VM_Program_Zero)	;Program load address

ProgramLaunch:
	
VramBase equ 0
ballpos equ 64+16
ballmove equ 64+18
PlayerPaddle equ 64+20
CpuPaddle equ 64+22
PlayerScore equ 64+24
CpuScore equ 64+25
GameTick equ 64+26
GameSpeed equ 64+27		
GameAI equ 64+28
SoundByte equ 64+29 


;                                     newgame:
newgame:
	dbbw mov16x,r6_imm16,(strstart-VramBase)
	
	db nopb
	
	advcall aprintseq
	db nopb
	db nopb
	
	
	
;                                     	call cls
	advcall acls
	
	
;                                     	ld hl,0x0000
	dbbw mov16x,r6_imm16,0x0000
	
;                                     titlescreen:
titlescreen:
;                                     	call pause50
	advcall apause50
;                                     	ld de,0x0000
	dbbw mov16x,r4_imm16,0x0000
;                                     	push hl
	db ph6b
;                                     		ld hl,strstart
	dbbw mov16x,r6_imm16,(strstart-VramBase)
;                                     		call printseq	
	advcall aprintseq
	
;                                     		ld hl,strspeed
	dbbw mov16x,r6_imm16,(strspeed-VramBase)
;                                     		call printseq	
	advcall aprintseq
;                                     	pop hl
	db pl6b
;                                     	ld a,h
	dbbb movx,r0_zeropg,vr7
;                                     	call showdecimal
	advcall ashowdecimal
;                                     

;                                     	push hl
	db ph6b
;                                     		ld hl,strai
	dbbw mov16x,r6_imm16,(strai-VramBase)
;                                     		call printseq	
	advcall aprintseq
;                                     	pop hl
	db pl6b
;                                     	ld a,l
	dbb movx,r0_r6
;                                     	call showdecimal
	advcall ashowdecimal
;                                     

;                                     	call readjoystick
	advcall areadjoystick
;                                     	ld c,a

	dbb movx,r2_r0
;                                     

;                                     	ld de,0x0004		;range
	dbbw mov16x,r4_imm16,0x0004
;                                     	ld a,l
	dbb movx,r0_r6
;                                     	call joyaxis		;up/down
	advcall ajoyaxis
;                                     	call rangelimit	
	advcall arangelimit
;                                     	ld l,a
	dbb movx,r6_r0
;                                     	ld a,h
	dbbb movx,r0_zeropg,vr7
;                                     	call joyaxis		;left/right
	advcall ajoyaxis
;                                     	call rangelimit	
	advcall arangelimit
;                                     	ld h,a
	dbbb movx,zeropg_r0,vr7
;                                     

;                                     	bit 0,c
	dbbb tstx,r2_imm8,1
	dbw bnej,(titlescreen-VramBase)
	
	
	
	
;                                     

;                                     	ld a,h
	dbbb movx,r0_zeropg,vr7
;                                     	call readmask
	dbw bsrj,(readmask-VramBase)
	
;                                     	ld (gamespeed),a
	dbbw stox,r0_addr16,gamespeed
;                                     
	
;                                     	ld a,l
	dbb movx,r0_r6
;                                     	call readmask
	dbw bsrj,(readmask-VramBase)
;                                     	ld (gameai),a
	
	
	dbbw stox,r0_addr16,gameai

;                                     
	
;                                     	call rezeroball			;init ball pos (center)
	dbw bsrj,(rezeroball-VramBase)
;                                     	ld a,e
	dbb movx,r0_r4

;                                     	ld (ballpos),a
	dbbw stox,r0_addr16,ballpos
;                                     	ld a,d
	dbbb movx,r0_zeropg,vr5
;                                     	ld (ballpos+1),a
	dbbw stox,r0_addr16,ballpos+1
;                                     	



;                                     	ld a,0xff				;ball pos -1 = facing player
	dbb movi,0xff
;                                     	ld (ballmove),a
	dbbw stox,r0_addr16,ballmove
;                                     	ld (ballmove+1),a
	dbbw stox,r0_addr16,ballmove+1
;                                     
	
;                                     	ld a,6
	dbb movi,6
;                                     	ld (playerpaddle),a		;ypos
	dbbw stox,r0_addr16,playerpaddle
;                                     	ld (cpupaddle),a
	dbbw stox,r0_addr16,cpupaddle
;                                     	

;                                     	ld a,0
	dbb movi,0
;                                     	ld (cpuscore),a
	dbbw stox,r0_addr16,cpuscore
;                                     	ld (playerscore),a
	dbbw stox,r0_addr16,playerscore
;                                     		

;                                     	ld (playerpaddle+1),a	;cpos
	dbbw stox,r0_addr16,playerpaddle+1
;                                     	ld a,19
	dbb movi,19
;                                     	ld (cpupaddle+1),a
	dbbw stox,r0_addr16,cpupaddle+1
;                                     

	;db nopb
	;db nopb
	;db nopb
	;db nopb

	; dbbw mov16x,r4_imm16,0x0808	;TEST
	; advcall acls
	; dbbw mov16x,r6_imm16,(strwall-VramBase)
	; advcall aprintseq
	

	advcall acls
	dbbw mov16x,r6_imm16,(strwall-VramBase)
	advcall aprintseq
;                                     

;                                     	

;                                     gameloop:
gameloop:
;                                     	ld a,(ballpos)				;de=ball pos x,y
	dbbw movx,r0_addr16,ballpos
;                                     	ld e,a
	dbb movx,r4_r0
;                                     	ld a,(ballpos+1)
	dbbw movx,r0_addr16,ballpos+1
;                                     	ld d,a
	dbbb movx,zeropg_r0,vr5
;                                     	push de
	db ph4b
;                                     		ld a,'o'
	dbb movi,'O'
;                                     		call printchar			;draw ball
	advcall aprintchar
;                                     

;                                     

;                                     		call getplayerpaddlede
	dbw bsrj,(getplayerpaddlede-VramBase)
;                                     		call drawpaddle			;draw player paddle
	dbw bsrj,(drawpaddle-VramBase)
;                                     

;                                     		call getcpupaddlede
	dbw bsrj,(getcpupaddlede-VramBase)
;                                     		call drawpaddle			;draw cpu paddle
	dbw bsrj,(drawpaddle-VramBase)
;                                     

;                                     		ld de,0x0011
	dbbw mov16x,r4_imm16,0x0011
;                                     		ld a,(playerscore)		;show player score
	dbbw movx,r0_addr16,playerscore
;                                     		call showdecimal
	advcall ashowdecimal
;                                     

;                                     		ld de,0x1111
	dbbw mov16x,r4_imm16,0x1111
;                                     		ld a,(cpuscore)			;show cpu score
	dbbw movx,r0_addr16,cpuscore
;                                     		call showdecimal
	advcall ashowdecimal
;                                     	

;                                     		ld a,(soundbyte)
	dbbw movx,r0_addr16,soundbyte
;                                     		call chibisound			;play sound
	advcall achibisound
;                                     	

;                                     		call pause50			;wait a bit
	advcall apause50
;                                     

;                                     		ld a,0
	dbb movi,0
;                                     		ld (soundbyte),a
	dbbw stox,r0_addr16,soundbyte
;                                     	pop de
	db pl4b
;                                     	push de
	db ph4b
;                                     		ld a,' '
	dbb movi,' '
;                                     		call printchar		;remove ball
	advcall aprintchar
;                                     	pop de
	db pl4b
;                                     

;                                     	ld a,(gamespeed)			;l=game speed mask
	dbbw movx,r0_addr16,gamespeed
;                                     	ld l,a
	dbb movx,r6_r0
;                                     

;                                     	ld a,(ballmove)				;bc=ball move x,y
	dbbw movx,r0_addr16,ballmove
;                                     	ld c,a
	dbb movx,r2_r0
;                                     	ld a,(ballmove+1)
	dbbw movx,r0_addr16,ballmove+1
;                                     	ld b,a
	dbb movx,r3_r0
;                                     	

;                                     	ld a,(gametick)
	dbbw movx,r0_addr16,gametick
;                                     	inc a
	db incb
;                                     	ld (gametick),a
	dbbw stox,r0_addr16,gametick
;                                     	and l						;move speed mask
	dbb andz,vr6
;                                     	call z,moveball				;update ball pos
	dbb bnei,3
	dbw bsrj,(moveball-VramBase)
lbl53141:
;                                     

;                                     	call getplayerpaddlede
	dbw bsrj,(getplayerpaddlede-VramBase)
;                                     	

;                                     	call readjoystick
	advcall areadjoystick
;                                     	ld c,a
	dbb movx,r2_r0
;                                     	call processpaddle			;move paddle from player input
	dbw bsrj,(processpaddle-VramBase)
;                                     	

;                                     	ld a,l
	dbb movx,r0_r6
;                                     	ld (playerpaddle),a
	dbbw stox,r0_addr16,playerpaddle
;                                     	ld a,h
	dbbb movx,r0_zeropg,vr7
;                                     	ld (playerpaddle+1),a
	dbbw stox,r0_addr16,playerpaddle+1
;                                     

;                                     	call getcpupaddlede
	dbw bsrj,(getcpupaddlede-VramBase)
;                                     	

;                                     	ld a,(gameai)
	dbbw movx,r0_addr16,gameai
;                                     	ld l,a
	dbb movx,r6_r0
;                                     

;                                     	ld a,(gametick)
	dbbw movx,r0_addr16,gametick
;                                     	and l			;make cpu dumber
	dbb andz,vr6
;                                     	jr nz,cpudecided
	dbw bnej,(cpudecided-VramBase)
;                                     

;                                     	ld c,0b11111111		;nomove
	dbbb movx,r2_imm8,0b11111111
;                                     

;                                     	ld a,(ballpos)
	dbbw movx,r0_addr16,ballpos
;                                     	sub 1
	dbb subi,1
;                                     	cp e
	dbb cmpz,vr4
;                                     	jr z,cpudecided	;no move
	dbw beqj,(cpudecided-VramBase)
;                                     

;                                     	jr c,cpuup		;move up
	dbw bcsj,(cpuup-VramBase)
;                                     	ld c,0b11111101		;move down
	dbbb movx,r2_imm8,0b11111101
;                                     	jr cpudecided
	dbb brai,cpudecided-lbl33183
lbl33183:
;                                     cpuup:
cpuup:
;                                     	ld c,0b11111110	
	dbbb movx,r2_imm8,0b11111110
;                                     cpudecided:
cpudecided:
;                                     	call processpaddle		;move paddle from cpu ai
	dbw bsrj,(processpaddle-VramBase)
;                                     	

;                                     	ld a,l
	dbb movx,r0_r6
;                                     	ld (cpupaddle),a
	dbbw stox,r0_addr16,cpupaddle
;                                     	ld a,h
	dbbb movx,r0_zeropg,vr7
;                                     	ld (cpupaddle+1),a
	dbbw stox,r0_addr16,cpupaddle+1
;                                     

;                                     	ld a,(cpuscore)
	dbbw movx,r0_addr16,cpuscore
;                                     	ld hl,playerscore
	dbbw mov16x,r6_imm16,playerscore
;                                     	or (hl)
	dbb orrx,r0_atr6
;                                     	cp 8
	dbb cmpi,8
;                                     	jp c,gameloop		;anyone reached 8 points?
	dbw bcsj,(gameloop-VramBase)
;                                     

;                                     	ld hl,strgameover
	dbbw mov16x,r6_imm16,(strgameover-VramBase)
;                                     	ld de,0x0608
	dbbw mov16x,r4_imm16,0x0608
;                                     	call printseq
	advcall aprintseq
;                                     

;                                     	call waitforfire
	advcall awaitforfire
;                                     	jp newgame
	dbw braj,(newgame-VramBase)
;                                     

;                                     	

;                                     getplayerpaddlede:
getplayerpaddlede:
;                                     	ld a,(playerpaddle)		;could just use ld de,(playerpaddle) on non gb
	dbbw movx,r0_addr16,playerpaddle
;                                     	ld e,a
	dbb movx,r4_r0
;                                     	ld a,(playerpaddle+1)
	dbbw movx,r0_addr16,playerpaddle+1
;                                     	ld d,a
	dbbb movx,zeropg_r0,vr5
;                                     	ret	
	db rtsb
;                                     

;                                     	

;                                     getcpupaddlede:
getcpupaddlede:
;                                     	ld a,(cpupaddle)		;could just use ld de,(cpupaddle) on non gb
	dbbw movx,r0_addr16,cpupaddle
;                                     	ld e,a
	dbb movx,r4_r0
;                                     	ld a,(cpupaddle+1)
	dbbw movx,r0_addr16,cpupaddle+1
;                                     	ld d,a
	dbbb movx,zeropg_r0,vr5
;                                     	ret	
	db rtsb
;                                     

;                                     	

;                                     moveball:
moveball:
;                                     	ld a,0b10100000
	dbb movi,0b10100000
;                                     	ld (soundbyte),a
	dbbw stox,r0_addr16,soundbyte
;                                     

;                                     	ld a,(playerpaddle)
	dbbw movx,r0_addr16,playerpaddle
;                                     	ld l,a
	dbb movx,r6_r0
;                                     	ld a,(playerpaddle+1)
	dbbw movx,r0_addr16,playerpaddle+1
;                                     	ld h,a
	dbbb movx,zeropg_r0,vr7
;                                     	

;                                     	ld a,d		
	dbbb movx,r0_zeropg,vr5
;                                     	cp 1					;hit player paddle
	dbb cmpi,1
;                                     	jr nz,noplayerpaddlehit
	dbw bnej,(noplayerpaddlehit-VramBase)
;                                     	call z,paddletest
	dbb bnei,3
	dbw bsrj,(paddletest-VramBase)
lbl30054:
;                                     	call c,cpuscores		;carry=missed paddle
	dbb bcci,3
	dbw bsrj,(cpuscores-VramBase)
lbl63924:
;                                     noplayerpaddlehit:
noplayerpaddlehit:
;                                     

;                                     	ld a,(cpupaddle)
	dbbw movx,r0_addr16,cpupaddle
;                                     	ld l,a
	dbb movx,r6_r0
;                                     	ld a,(cpupaddle+1)
	dbbw movx,r0_addr16,cpupaddle+1
;                                     	ld h,a
	dbbb movx,zeropg_r0,vr7
;                                     	ld a,d	
	dbbb movx,r0_zeropg,vr5
;                                     	cp 18					;hit cpu paddle
	dbb cmpi,18
;                                     	jr nz,nocpupaddlehit
	dbw bnej,(nocpupaddlehit-VramBase)
;                                     	call z,paddletest
	dbb bnei,3
	dbw bsrj,(paddletest-VramBase)
lbl22357:
;                                     	call c,playerscores
	dbb bcci,3
	dbw bsrj,(playerscores-VramBase)
lbl32009:
;                                     nocpupaddlehit:
nocpupaddlehit:
;                                     

;                                     	ld a,d
	dbbb movx,r0_zeropg,vr5
;                                     	add b			;update ball xpos
	dbb addz,vr3
;                                     	ld d,a	
	dbbb movx,zeropg_r0,vr5
;                                     

;                                     	ld a,e
	dbb movx,r0_r4
;                                     	add c			;update ball ypos
	dbb addz,vr2
;                                     	ld e,a
	dbb movx,r4_r0
;                                     	

;                                     	cp 1			;hit top wall
	dbb cmpi,1
;                                     	call z,flipy
	dbb bnei,3
	dbw bsrj,(flipy-VramBase)
lbl7477:
;                                     	cp 16			;hit bottom wall
	dbb cmpi,16
;                                     	call z,flipy
	dbb bnei,3
	dbw bsrj,(flipy-VramBase)
lbl34204:
;                                     

;                                     	ld a,e
	dbb movx,r0_r4
;                                     	ld (ballpos),a
	dbbw stox,r0_addr16,ballpos
;                                     	ld a,d
	dbbb movx,r0_zeropg,vr5
;                                     	ld (ballpos+1),a
	dbbw stox,r0_addr16,ballpos+1
;                                     	

;                                     	ld a,c
	dbb movx,r0_r2
;                                     	ld (ballmove),a
	dbbw stox,r0_addr16,ballmove
;                                     	ld a,b
	dbb movx,r0_r3
;                                     	ld (ballmove+1),a
	dbbw stox,r0_addr16,ballmove+1
;                                     	ret
	db rtsb
;                                     

;                                     	

;                                     paddletest:		;carry=missed paddle
paddletest:
;                                     	ld a,e
	dbb movx,r0_r4
;                                     	cp l
	dbb cmpz,vr6
;                                     	jr c,paddlemiss
	dbw bcsj,(paddlemiss-VramBase)
;                                     	sub 3
	dbb subi,3
;                                     	cp l
	dbb cmpz,vr6
;                                     	jr nc,paddlemiss
	dbw bccj,(paddlemiss-VramBase)
;                                     	call flipx
	dbw bsrj,(flipx-VramBase)
;                                     

;                                     	ld a,0b01000000
	dbb movi,0b01000000
;                                     	ld (soundbyte),a
	dbbw stox,r0_addr16,soundbyte
;                                     	or a		;clear carry
	dbb orrz,vr0
;                                     	ret
	db rtsb
;                                     	

;                                     	

;                                     paddlemiss:
paddlemiss:
;                                     	ld a,0b01110000
	dbb movi,0b01110000
;                                     	ld (soundbyte),a
	dbbw stox,r0_addr16,soundbyte
;                                     	scf		;set carry
	dbbb movx,rF_imm8,3
;                                     	ret
	db rtsb
;                                     	

;                                     cpuscores:
cpuscores:
;                                     	ld hl,cpuscore
	dbbw mov16x,r6_imm16,cpuscore
;                                     	inc (hl)
	dbb incx,atr6_atr6
;                                     	call rezeroball
	dbw bsrj,(rezeroball-VramBase)
;                                     	ret
	db rtsb
;                                     

;                                     	

;                                     playerscores:
playerscores:
;                                     	ld hl,playerscore
	dbbw mov16x,r6_imm16,playerscore
;                                     	inc (hl)
	dbb incx,atr6_atr6
;                                     					;rezero ball

;                                     rezeroball:
rezeroball:
	
	
;                                     	ld de,0x0a08
	dbbw mov16x,r4_imm16,0x0a08
;                                     					;flip direction of ball

;                                     flipx:	
flipx:
;                                     	ld a,b
	dbb movx,r0_r3
;                                     	cpl ;neg
	dbb vxori,255
;                                     	inc a
	db incb
;                                     	ld b,a
	dbb movx,r3_r0
;                                     	ret
	db rtsb
;                                     

;                                     	

;                                     flipy:
flipy:
;                                     	ld a,c
	dbb movx,r0_r2
;                                     	cpl ;neg
	dbb vxori,255
;                                     	inc a
	db incb
;                                     	ld c,a
	dbb movx,r2_r0
;                                     	ret
	db rtsb
;                                     

;                                     	

;                                     drawpaddle:
drawpaddle:
;                                     	ld hl,strpaddle
	dbbw mov16x,r6_imm16,(strpaddle-VramBase)
;                                     	call printseq
	advcall aprintseq
;                                     	ret
	db rtsb
;                                     

;                                     	

;                                     processpaddle:
processpaddle:
;                                     	push de
	db ph4b
;                                     	push bc
	db ph2b
;                                     		ld hl,strblankpaddle
	dbbw mov16x,r6_imm16,(strblankpaddle-VramBase)
;                                     		call printseq
	advcall aprintseq
;                                     	pop bc
	db pl2b
;                                     	pop hl
	db pl6b
;                                     

;                                     	ld de,0x010f
	dbbw mov16x,r4_imm16,0x010f
;                                     	ld a,l
	dbb movx,r0_r6
;                                     	call joyaxis		;up/down
	advcall ajoyaxis
;                                     	call rangelimit	
	advcall arangelimit
;                                     	ld l,a
	dbb movx,r6_r0
;                                     	ret
	db rtsb
;                                     

;                                     	

;                                     readmask:
readmask:
;                                     	push hl
	db ph6b
;                                     		ld hl,masks
	dbbw mov16x,r6_imm16,(masks-VramBase)
;                                     		ld d,0
	dbbbb movx,zeropg_imm8,vr5,0
;                                     		ld e,a
	dbb movx,r4_r0
;                                     		add hl,de
	dbb add16x,r6_r4
;                                     		ld a,(hl)
	dbb movx,r0_atr6
;                                     	pop hl
	db pl6b
	db rtsb
;                                     

;Speed masks for ball and AI	
Masks:	.db 0b00000111,0b00000011,0b00000001,0b00000000


strGameOver:.db "Game Over",255
strStart:	.db "Pongo!",253,255

strSpeed:	.db 253,"Speed:",255
strAi:		.db 253,"AI:",255


strWall:	.db 0xB3,"-"
			.db 253
			.db 0xF1	;253=Newline (Xpos=0) 0xF1= Ypos=17
			 .db 0xB3,"-"
			 .db 255		;0xB3=18 char H strip

strPaddle: 	 	 .db 0xC2,"X",255 ;0xC2=3 char V strip
strBlankPaddle:  .db 0xC2," ",255


vm_traps: 	dw ProgramLaunch
			dw 0
vm_addressremaptable:

VM_Program_End:
	

	
	
text:
	.db "HELlo World",255
	.align 4

	
	.include "Footer.asm"


