;s0	r0  A				
;s1	r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4	r4  C
;s5	r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)


	.include "Header.asm"


	.include "\SrcAll\BasicMacros.asm"
  
CursorX equ 0x100 		;Defined symbols CursorX EQUals 0x100
CursorY equ 0x101


;These routines work in Little Endian even if the CPU is big endian

	;jal Cls				;Zero Graphics cursor pos
	;nop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
	li s2,1
	li s5,3
  
	la s3,text 			;A0 = String (255 terminated)
	jal PrintString		;Print String 
	nop
  
	jal NewLine         ;Move down a line
	nop
	
	la a2,text			;Address
	li a1,2				;Line Count
	jal MemDump			;Dump Ram to screen
	nop
	
	
	
	
	;la s3,text2 			;A0 = String (255 terminated)
	;jal printseq		;Print String 
	;nop
	
	;jal FillArea
	;nop
InfLoop:	
	jal ReadJoystick
	
	li s2,0
	li s5,10
	jal Monitor			;Reg Dump
	nop
	
	j InfLoop			;Wait forever
	nop 				;Delay Slot
	
	
	la a2,text			;Address
	li a1,2				;Line Count
	jal MemDump			;Dump Ram to screen
	nop
	
	
	li s2,5
	li s5,5
	li s1,6
	li s4,3
	li s3,33
	li s6,0
	
	
	jal WaitForFire
	nop
	
	;jal pause50
	;nop
	
	li s2,0x50
	li s5,0x60
	
	
	jal RangedRandom	;ReadJoystick
	nop
	
	li s2,0
	li s5,10
	jal Monitor			;Reg Dump
	nop
	
	li s0,234
	
	jal ShowDecimal
	nop
	
	
text2:
	
	.db "H",0xFE,"ello",254,"World",0xa0+4,"-",0xc0+4,"|",251,5,4,'!',1,255
	
	
	
text:
	.db "HELlo World",255
	
	
	.align 4	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	.include "core.asm"
	.include "monitor.asm"  	
	.include "Footer.asm"


