;s0	r0  A				
;s1	r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4	r4  C
;s5	r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)



Monitor:
    pushAll
		li a0,'r'
		li a1,'a'
		move a2,ra
		jal ShowRegText                ;A5 A6 : A7
		nop
		
		li a0,'s'
		li a1,'p'
		move a2,sp
		addi a2,0x64
		jal ShowRegText                ;A5 A6 : A7
		nop
		
		li a0,'g'
		li a1,'p'
		move a2,gp
		jal ShowRegText                ;A5 A6 : A7
		nop
		
		
		jal NewLine         
		nop	
		
		li a0,'f'
		li a1,'p'
		move a2,fp
		jal ShowRegText                ;A5 A6 : A7
		nop
	
	
		li a0,'v'
		li a1,'0'
		lw a2,4(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,8(sp)
		jal ShowReg                ;A5 A6 : A7      
		nop
		
	
		jal NewLine         
		nop	
	
	
	
		li a0,'a'
		li a1,'0'
		lw a2,12(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,16(sp)
		jal ShowReg                ;A5 A6 : A7      
		nop
		lw a2,20(sp)
		jal ShowReg                ;A5 A6 : A7      
		nop
		
		
		jal NewLine         
		nop
		
		lw a2,24(sp)
		jal ShowReg                ;A5 A6 : A7      	
		nop
		
	
		li a0,'t'
		li a1,'0'
		lw a2,28(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,32(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		jal NewLine         
		nop
		
		lw a2,36(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,40(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,44(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		jal NewLine         
		nop
		
		lw a2,48(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,52(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,56(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		jal NewLine         
		nop
		
		lw a2,60(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,64(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		
		
		li a0,'s'
		li a1,'0'
		lw a2,68(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		
		jal NewLine         
		nop
		
		lw a2,72(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,76(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,80(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		jal NewLine         
		nop
		lw a2,84(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,88(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		lw a2,92(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		
		jal NewLine         
		nop
		
		lw a2,96(sp)
		jal ShowReg                ;A5 A6 : A7
		nop
		
		
		li a0,'k'
		li a1,'0'
		move a2,k0
		jal ShowReg                ;A5 A6 : A7
		nop
		move a2,k1
		jal ShowReg                ;A5 A6 : A7
		nop
		
		jal NewLine        
		nop
		
		li a0,'H'
		li a1,'I'
		mfhi a2
		jal ShowRegText                ;A5 A6 : A7
		nop
		
		li a0,'L'
		li a1,'O'
		mflo a2
		jal ShowRegText                ;A5 A6 : A7
		nop
		
		li a0,'P'
		li a1,'C'
		lw a2,0(sp)
		
		jal ShowRegText                ;A5 A6 : A7
		nop
		
		jal NewLine        
		nop
		
    pop ra
	popVs
	popAs
	popTs
	;popSs
	  lw s0,0(sp)		;Load registers of the stack
      lw s1,4(sp)
      ;lw s2,8(sp)		;Xpos for Adventure engine Printchar
      lw s3,12(sp)
	  lw s4,16(sp)
      ;lw s5,20(sp)		;Ypos for Adventure engine Printchar
      lw s6,24(sp)
      lw s7,28(sp)
      addi sp,sp,32		;Release space for 8 registers
	
    jr ra
	nop


ShowRegTextB:
	push ra
	push s0
	push a3
		jal ShowRegText
		nop
	pop a3
	pop s0
	pop ra
	jr ra
	nop

ShowRegText:                ;A5 A6 : A7
  push ra
     move s0,a0
     jal PrintChar
	 nop
     move s0,a1
     jal PrintChar
	 nop
  j ShowRegB	
	nop
	
ShowReg:                ;A5 A6 : A7
	push ra
		 move s0,a0
		 jal PrintChar
		 nop
		 move s0,a1
		 jal ShowHexChar
		 nop
ShowRegB:               ;A5 A6 : A7
		 li s0,':'
		jal PrintChar
		nop
		move a3,a2
		jal ShowHex4
		nop
		li s0,' '
		jal PrintChar
		nop
		addi a1,a1,1
		
		
	pop ra
	jr ra
	nop
	
ShowHex4:		;Show A3
  push ra
		li t4,8
ShowHex4Again:  
        srl s0,a3,28
        sll a3,a3,4	

		push t4
			jal ShowHexChar
			nop
		pop t4
      addi t4,t4,-1
      bne t4,zero,ShowHex4Again
	  nop
  pop ra
  jr ra
  nop
  
ShowHex2:
	push ra
	pushAs
		li a1,2
ShowHex2Again:  
			move s0,a3
			srl s0,a3,4
			sll a3,a3,4
			
			jal ShowHexChar
			nop
			
		  addi a1,a1,-1
		  bne a1,zero,ShowHex2Again
		  nop
	popAs
	pop ra
	jr ra
	nop
	
ShowHexChar:
	push ra
	pushAs
	push t0
		andi s0,s0,0xF
		addi s0,s0,'0'
		li t0,':'
		blt s0,t0,ShowHexCharOk
		nop
		addi s0,s0,7
ShowHexCharOk:
		jal PrintChar
		nop
	pop t0
	popAs
	pop ra
	jr ra
	nop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
MemDumpNoLabel:
	pushAll
	j MemDumpb
	nop
	
MemDump:
	;pushAll
	push ra	
		pushAs
			
		
			move a3,a2
			jal ShowHex4	
			nop
			li s0,':'
			jal PrintChar
			nop
		popAs
MemDumpb:
MemDumpNextLine:		
		jal NewLine
		nop
		li a0,8
MemDumpAgain:
		lb a3,(a2)
		jal ShowHex2
		nop
		li s0,' '
		jal PrintChar
		nop
		addi a2,a2,1
		addi a0,a0,-1
		bne a0,zero,MemDumpAgain
		nop
		
		addi a2,a2,-8
		li a0,8
MemDumpAgainChar:
		lb s0,(a2)
		li t1,32
		blt s0,t1,MemDumpAgainCharBad
		nop
		li t1,128
		bgt s0,t1,MemDumpAgainCharBad
		nop
		j MemDumpAgainCharOk
		nop
MemDumpAgainCharBad:				
		li s0,'.'
MemDumpAgainCharOk:		
		jal PrintChar
		nop
		addi a2,a2,1
		addi a0,a0,-1
		bne a0,zero,MemDumpAgainChar
		nop
		
		addi a1,a1,-1
		bne a1,zero,MemDumpNextLine
		nop
		jal NewLine 
		nop
	pop ra
	;popAll
	jr ra
	nop