
.include "\SrcAll\Header.asm"
.include "\SrcAll\BasicMacros.asm"
  
CursorX equ 0x100 		;Defined symbols CursorX EQUals 0x100
CursorY equ 0x101

	jal Cls				;Zero Graphics cursor pos
	nop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
	la a0,text 			;A0 = String (255 terminated)
	jal PrintString		;Print String 
	nop
  
	jal NewLine         ;Move down a line
	nop
	
	jal Monitor			;Show Registers to screen
	nop
    
	li t7,UserRam		;Address
	li t6,2				;Line Count
	
	jal MemDump			;Dump Ram to screen
	nop
  
InfLoop:
	j InfLoop			;Wait forever
	nop 				;Delay Slot
  
Text:
	.db "Hello World",255
	.align 4 			;Align 32-Bit

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
MyFont:
.ifdef buildn64				
	.incbin "\ResN64\ChibiAkumas.fnt"	;Included binary data
.endif
.ifdef buildPSX		
	.incbin "\ResPSX\ChibiAkumas.fnt"
.endif

.include "\SrcALL\graphics.asm"			;Included ASM files
.include "..\\SrcAll\monitor.asm"  	
.include "\SrcN64\Footer.asm"

