
.psx
.create "\BldPSX\Prog.bin", 0x80010000

.definelabel UserRam,0x0010F000
.definelabel JoyData,0x0010F200	;The Bios will save joypad buttons here

.definelabel ramarea,0x00110000

	.org 0x80010000 ; Entry Point Of Code

	
	lui a0,0x1F80 			;IO_BASE 0x1F80xxxx

; Setup Screen Mode
;We send settings to GP0 Command Control 0x1F80 1814
		;   CCPPPPPP - CC = Command PPPPPP=Parameter
    li t0,0x00000000		;$00=Reset
    sw t0,0x1814(a0)	   
	
    li t0,0x03000000		;$03=Display Enable
    sw t0,0x1814(a0)	 
	
    li t0,0x08000001		;$80=Display Mode (320x240 16bpp)
    sw t0,0x1814(a0)	   
	
    li t0,0x06C60260		;$06= H Display Range (3168-608)
    sw t0,0x1814(a0)	   
	
    li t0,0x07042018        ;$07= V Display Range (264-24)
	sw t0,0x1814(a0)	    

;Setup Screen Area
	li t0,0xE1000400
    sw t0,0x1810(a0)		;GP0 Command Port 0x1F80 1810
	
	li t0,0xE3000000		;$E3 - Drawing Area TopLeft
								;%YYYYYYYYYYXXXXXXXXXX
    sw t0,0x1810(a0)		;GP0 Command Port 0x1F801810
	
	li t0,0xE403BD3F		;$E4 - Drawing area Bottom Right
								;%YYYYYYYYYYXXXXXXXXXX
    sw t0,0x1810(a0)		;GP0 Command Port 0x1F801810
	
	li t0,0xE5000000		;$E5 - Drawing Offset 
    sw t0,0x1810(a0)		;GP0 Command Port 0x1F801810
		
		
;Fill Screen
    li t0,0x02000000		;$02 - Fill Area 1- 0x02BBGGRR - Background 
    sw t0,0x1810(a0)			;02BBGGRR
		
    li t0,0x00000000		;$02 - Fill Area 2-0xYYYYXXXX - Topleft
    sw t0,0x1810(a0)			;YYYYXXXX
		
    li t0,0x0EF0013F		;$02 - Fill Area 3-0xHHHHWWWW - HeightWidth
	sw t0,0x1810(a0)			;HHHHWWWW  $EF x $137 = 239 x 319
	
	
	li sp,UserRam			;Init Stack Pointer
		
;B(12h) InitPad(buf1,siz1,buf2,siz2)
	li t0,0xB0			;Bios Functions
	li t1,0x12			;12: InitPad
	
	la a0,JoyData		;Pad Dest
	li a1,0x22			;BufferSize
	li a2,JoyData+0x30	;Pad Dest 2
	li a3,0x22			;BufferSize 2
	jalr t0				;Call the bios function
	nop 
	
;B(13h) StartPad()
	li t0,0xB0			;Bios Functions
	li t1,0x13			;13: StartPad
	jalr t0				;Call the bios function
	nop 
	
	
	