	
	.macro dw36,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32,p33,p34,p35,p36
		dw (p1)
		dw (p2)
		dw (p3)
		dw (p4)
		dw (p5)
		dw (p6)
		dw (p7)
		dw (p8)
		dw (p9)
		dw (p10)
		dw (p11)
		dw (p12)
		dw (p13)
		dw (p14)
		dw (p15)
		dw (p16)
		dw (p17)
		dw (p18)
		dw (p19)
		dw (p20)
		dw (p21)
		dw (p22)
		dw (p23)
		dw (p24)
		dw (p25)
		dw (p26)
		dw (p27)
		dw (p28)
		dw (p29)
		dw (p30)
		dw (p31)
		dw (p32)
		dw (p33)
		dw (p34)
		dw (p35)
		dw (p36)
	.endmacro 	
	

;s0 r0  A				
;s1 r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4 r4  C
;s5 r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)

;t9/a0 r10	 (Was A0 / r10)
;t9/a1 r11	 (Was A0 / r10)

;v0=zero flag
;v1=carry flag
	




DoMaxTileCall:	 ;Return address is on stack!
		la t7,vecMaxTile
	j ChibiVM_VectorCall	
	nop


mxMaxTileInit equ 0				;NoParams (sets up LUTs
mxMaxTileRedraw equ 1			;NoParams
mxMaxTileFillArea equ 2		;B,C=X,Y pos HL=Tile to fill with  D,E=Wid,Hei
mxMaxTileDrawArea equ 3		;B,C=X,Y pos HL=SourceTilemap (2 byte per tile)  D,E=Wid,Hei  (Draw a tilemap/sprite to screen)
mxMaxTilePrint equ 4			;HL=source tilemap BC=xy pos de=offset (FF=End of line FF FF = end of string - 1 byte per tile DE=Offset)
mxSetPalette equ 5				;HL=Platform specific palette
mxSetScroll equ 6				;HL=TileMap Base Addr (if A=255 else unchanged) DE = Xoffset,Yoffset (only bottom 4 bits used)
mxDrawBorder equ 7				;NoParams
mxFlagForRedraw equ 8			;B,C=X,Y pos D,E=Wid,Hei

SetPalette:
	jr ra				;Return
	nop
	
vecMaxTile:
	.dw InitMaxTile				;0
	.dw MaxTileRedraw			;1
	.dw MaxTileFillArea			;2
	.dw MaxTileDrawArea			;3
	.dw MaxTilePrint				;4
	.dw SetPalette				;5
	.dw MaxTileSetScroll				;HL=TileMap Base Addr (if A=255 else unchanged) DE = Xoffset,Yoffset (only bottom 4 bits used)
	.dw MaxTileClearBorder
	.dw MaxTileFlagForRedraw
;ShiftTilemap ;r4/C=Ypos r1/B=Xpos... Returns HL address

;BackgroundTilemapScrollX
;BackgroundTilemapScrollY
;InitMaxTile

;adrbackgroundtilemapbase: .dw backgroundtilemapbase

;R6 HL=TileMap Base Addr (if r0 A=255 else unchanged) r4 C = Xoffset r5 D = Yoffset (only bottom 4 bits used)
MaxTileSetScroll:		
	la s1,BackgroundTilemapScrollX
	sb s4,(s1)
	
	la s1,BackgroundTilemapScrollY
	sb s5,(s1)

	li t0,255
	bne s0,t0,MaxTileSetScroll_Done
	nop
	la s1,backgroundtilemapbase
	sw s6,(s1)
	
MaxTileSetScroll_Done:		
	jr ra				;Return
	nop
	
	
ShiftTilemap:
	la s6,backgroundtilemapbase
	lw s6,(s6)
	;move.l (backgroundtilemapbase),a3
	sll a0,s4,3		;*8 
	
	;mov r10,r4,lsl #3	
	
	.ifndef backgroundtilemapwidth32
		add s6,s6,a0		;hardcoded to 36*2 wide tilemap
	.endif
		
	sll a0,a0,3	;*64 1536
	add s6,s6,a0			;add ypos to A3

	li s4,backgroundtilemapwidthv*2
	
	sll s0,s1,1	;2 bytes per tile
	add s6,s6,s0			;add xpos D1 to A3
	
;	mov pc,lr			;D4/C=Tilemap Width
	jr ra				;Return
	nop
		

MaxTileFlagForRedraw:;d1,d4 = XY d2,d5=wh
		
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		jal ShiftTilemap
		nop
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer


ResetTilemapPart:
	move s1,s2
	move s3,s6
resettilemappartb:
		lbu s0,(s6)
		nop
		ori s0,s0,0x0001
		sb s0,(s6)		;flag tile for redraw
		addi s6,s6,2
		addi s1,s1,-1
		bne s1,zero,resettilemappartb
		nop
	move s6,s3

	add s6,s6,s4			;Down a line
	addi s5,s5,-1
	bne s5,zero,ResetTilemapPart
	nop
	jr ra				;Return
	nop
	
;r6/HL=source tilemap r1/r4=BC=xy pos r5/de=offset (FF=End of line FF FF = end of string - 1 byte per tile DE=Offset)
MaxTilePrint:	
	move t8,s6		;r9
	move t7,s5		;r8
		;STMFD sp!,{lr}
		

	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		jal ShiftTilemap
		nop

	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer

MaxTilePrintY:
	move s3,s6
MaxTilePrintX:
		lbu s0,(t8)
		addi t8,t8,1
		;ldrb r0,[r9],#1
		li t0,255
		beq s0,t0,MaxTilePrint_Xdone
		nop
		
		sll t0,s0,4			;Move byte to top and add offset
		add s0,t0,t7		
		
		;add r0,r8,r0,lsl #4
		
		sb s0,(s6)	;Store Tile
		addi s6,s6,1
		
		srl s0,s0,8
		
		sb s0,(s6)
		addi s6,s6,1
		
		j MaxTilePrintX
		nop
MaxTilePrint_Xdone:
	lbu s0,(t8)
	li t0,255
	beq t0,s0,MaxTilePrint_Ydone
	nop
	
	move s6,s3

	add s6,s6,s4			;Down a line
	j MaxTilePrintY
	nop
MaxTilePrint_Ydone:
	jr ra				;Return
	nop
	
	
;R1,R4 B,C=X,Y pos R6/HL=Tile to fill with  R2,R5 D,E=Wid,Hei	
MaxTileDrawArea:	
	move t8,s6
	
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw ra,0(sp)			;Put the register onto the stack

		;STMFD sp!,{lr}
			jal ShiftTilemap
			nop
		;LDMFD sp!,{lr}

		lw ra,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer

MaxTileDrawAreaY:
	move s1,s2
	move s3,s6
MaxTileDrawAreaX:
		lbu s0,(t8)
		addi t8,t8,1
		sb s0,(s6)		;Store Tile
		addi s6,s6,1
		
		lbu s0,(t8)
		addi t8,t8,1
		sb s0,(s6)		;Store Tile
		addi s6,s6,1
		
		addi s1,s1,-1
		bne s1,zero,MaxTileDrawAreaX
		nop
	move s6,s3

	add s6,s6,s4			;Down a line
	addi s5,s5,-1
	bne s5,zero,MaxTileDrawAreaY
	nop
	jr ra				;Return
	nop
	
	
	
;B,C=X,Y pos HL=Tile to fill with  D,E=Wid,Hei
MaxTileFillArea:			
	move t8,s6
	srl t7,s6,8
	
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw ra,0(sp)			;Put the register onto the stack

		;STMFD sp!,{lr}
			jal ShiftTilemap
			nop
		;LDMFD sp!,{lr}
		lw ra,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer

MaxTileFillAreaY:
	move s1,s2
	move s3,s6
MaxTileFillAreaX:
		sb t8,(s6)
		addi s6,s6,1
		sb t7,(s6)
		addi s6,s6,1	;Store Tile

		
		;subs r1,r1,#1
		addi s1,s1,-1
		bne s1,zero,MaxTileFillAreaX
		nop
	move s6,s3

	add s6,s6,s4			;Down a line
	addi s5,s5,-1
	bne s5,zero,MaxTileFillAreaY
	nop
	jr ra				;Return
	nop

	
	
	
	
	
MaxTileRedraw:						;Draw straight to VRAM
	.ifdef BuildN64
		la s6,AdrScreenBase
		lw s6,(s6)
	.endif
	.ifdef BuildPSX
		li s6,0
	.endif
	
	la s5,backgroundtilemapbase
	lw s5,(s5)
	la s4,MaxTilePatterns
	
								;Center Vscreen
		;add r6,r6,#16			;(160-120)/2
		;add r6,r6,#0xF00		;(240-192/2)*160
		
		li s7,32
		li t7,24
		li t8,BackgroundTilemapWidthV*2
	
	la s1,BackgroundTilemapScrollX
	lbu s1,(s1)
	
	la s2,BackgroundTilemapScrollY
	lbu s2,(s2)
	
	andi s1,s1,0b00000011
	beq s1,zero,MaxTileRedraw_NoXShift
	nop
	;.ifdef BuildGBA
		;add r6,r6,r1
	;.endif
	.ifdef BuildN64
		sll t0,s1,2
		add s6,s6,t0
	.endif
	.ifdef BuildPSX
		sll t0,s1,1			;Pixels to LU
		add s6,s6,t0
	.endif
	;.ifdef BuildROS
;		add r6,r6,r1,lsr #2;
	;.endif
	addi s7,s7,-1			;Do one less X tile
MaxTileRedraw_NoXShift:	
	andi s2,s2,0b00000011
	beq s2,zero,MaxTileRedraw_NoYShift
	nop
	addi t7,t7,-1			;Do one less Y tile
	.ifdef BuildPSX
		sll t0,s2,1			;Pixels to LU
		sll t0,t0,16		; YYYYXXXX
		add s6,s6,t0
	.endif
	
	 .ifdef BuildN64
			li t1,320	;Bytes per line+Char
			move t0,s2
			sll t0,t0,2
			multu t1,t0
			mflo s0
		 
		 add s6,s6,s0
	 .endif
	
MaxTileRedraw_NoYShift:	
	
	
;BC/r4  = Pattern Source
;DE/r5  = Source Tilemap
;HL/r6  = Vram Dest 
;IXH/D4/r7 = Draw Width IXL/D8=Draw Height
;IYH/A6/r9 = TilemapWidth

DrawTilemap:						;Draw straight to VRAM

	
NextLineD:
	;STMFD sp!,{r7,r5,r6}
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s7,0(sp)			;Put the register onto the stack
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s6,0(sp)			;Put the register onto the stack
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s5,0(sp)			;Put the register onto the stack


	
nexttile:	
		lbu s0,(s5)		;A2=tilemap data 
		nop
		andi v1,s0,0b00000001
		srl s0,s0,1			;get the 'needs update' bit
					
		.ifdef doublebuffered
			j drawtile	;update even if not needed!
			nop
		.else
			bne v1,zero,drawtile	;update if needed
			nop
		.endif
emptytile:
		addi s5,s5,2 		;a2=tilemap data %NNNNXYPU %nnnnnnnn
TileDone:
;Platform specific commands to move across 8 pixels (one tile)

		
		.ifdef buildN64
			addi s6,s6,16		;Across one tile
		.endif
		.ifdef buildPSX
			addi s6,s6,8		;Across one tile
		.endif
		
		addi s7,s7,-1
		bne s7,zero,nexttile
		nop
tiledone2:
	;moveM.l (sp)+,a2/a3/d7	;tilemap source / screen pos / width
	;LDMFD sp!,{r7,r5,r6}
	lw s5,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	lw s6,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	lw s7,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer	
	
;Platform specific commands to move down 8 pixels (one strip of tiles)
	
	.ifdef buildN64
		addi s6,s6,320*2*8		;Down one strip
	.endif
	
	.ifdef buildPSX
		li t0,0x00080000
		add s6,s6,t0		;Down one strip
	.endif
	add s5,s5,t8				;Down a tilemap source
	
	addi t7,t7,-1				;Next v-line
	bne t7,zero,nextlined				;Repeat for next line
	nop
	
	jr ra				;Return
	nop
	
	
	
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
	
	
	.ifdef BuildN64
		.include "\SrcN64\N64_V1_MaxTile.asm"	;MUST come before Adventure Engine!
	.endif
	.ifdef BuildPSX
		.include "\SrcPSX\PSX_V1_MaxTile.asm"	;MUST come before Adventure Engine!
	.endif
		
	.ifdef ScreenBase
AdrScreenBase: .dw ScreenBase
	.endif
;AdrBackgroundTilemapScrollX: .long BackgroundTilemapScrollX
;AdrBackgroundTilemapScrollY: .long BackgroundTilemapScrollY

	
	