	

NativeSpriteCall:	 ;Return address is on stack!
	la t7,vecNS
	j ChibiVM_VectorCall	
	nop
nsInit equ 0	
nsDraw equ 1
nsDrawExtra equ 2
nsDrawArray equ 3
nsHide equ 4
nsClearUnused equ 5
nsHideAll equ 6

vecNS:
	.dw NativeSpr_InitReiKou ;dw NativeSpr_InitReiKou	;0
	.dw DummySyscall ;dw NativeSpr_Draw	;1
	.dw DummySyscall ;dw NativeSpr_DrawExtra ;2
	.dw NativeSpr_DrawArrayReiKou ;dw NativeSpr_DrawArrayReiKou ;3
	.dw DummySyscall ;dw NativeSpr_Hide ;4
	.dw DummySyscall ;dw NativeSpr_ClearUnused ;5
	.dw nativespr_hideall_reikou

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
	
NativeSpr_InitReiKou:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		jal AddressRemapViaTableR6	;16 bit -> 32 bit address conversion
		nop
		j NativeSpr_Initb
		nop
		
NativeSpr_Init:			;r6=Sprite source
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

NativeSpr_Initb:	
		la a0,nativespriteaddr
		sw s6,(a0)
	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	
NativeSpr_DrawArrayReikou:	;S5=Table

	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
	
		jal AddressRemapViaTableR6	
		nop
		la s5,nativespriteactivebuffer
		
		lbu s7,(s6)  	;Sprite Count
		addi s6,s6,1
		
		sb s7,(s5)  	;Sprite Count
		addi s5,s5,1

NativeSpr_DrawArrayB_RK:
		
		beq s7,zero,NativeSpr_ClearUnused_RK
		nop
		
		jal nativespr_testoneRK
		nop
		
		beq v1,zero,nativespr_nochangeRK
		nop
		
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s7,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s6,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s5,0(sp)			;Put the register onto the stack
		
			addi sp,sp,-4		;Subtract 4 from Stack pointer
			sw s6,0(sp)			;Put the register onto the stack
	
				move s6,s5
				jal nativespr_drawoneRK  ;R5
				nop
			
			lw s6,0(sp)		;Pop the register off the stack
			addi sp,sp,4		;Add 4 to the Stack pointer

			jal nativespr_drawoneRK	;R6
			nop
		
		lw s5,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointe
		lw s6,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer	
		lw s7,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
		
nativespr_nochangeRK:		
		li s1,4
nativespr_TransferRK:
		lbu s0,(s6)		;Copy 4 bytes
		addi s6,s6,1
		sb s0,(s5)
		addi s5,s5,1
		
		addi s1,s1,-1
		bne s1,zero,nativespr_TransferRK
		nop
		
		addi s7,s7,-1
		j NativeSpr_DrawArrayB_RK
		nop

NativeSpr_ClearUnused_RK:
	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	
	jr ra				;Return
	nop
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nativespr_hideall_reikou:
	;STMFD sp!,{lr}
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
	
		la s6,nativespriteactivebuffer
		lbu s7,(s6)	  	;Sprite Count
		
		sb zero,(s6)
		addi s6,s6,1
		
		; mov r5,#0
		; mov r2,#0
		; bl monitor
		; b $
nativespr_drawarrayb_hideRK:
		;cmp r7,#0
		beq s7,zero,NativeSpr_ClearUnused_RK
		nop
		
		;STMFD sp!,{r7,r6,r5}
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s7,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s6,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s5,0(sp)			;Put the register onto the stack
		
		
			jal nativespr_drawoneRK
			nop
		;LDMFD sp!,{r7,r6,r5}
		
		lw s5,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointe
		lw s6,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer	
		lw s7,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
	
	
		li s1,4			;4 bytes per entry
nativespr_drawarrayb_hideClearAgainRK:		
		sb zero,(s6)
		addi s6,s6,1		;Clear this entry
		
		addi s1,s1,-1
		bne s1,zero,nativespr_drawarrayb_hideClearAgainRK	
		nop
		
		addi s7,s7,-1
		j nativespr_drawarrayb_hideRK
		nop
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	

nativespr_hideall:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		la s6,nativespriteactivebuffer
		lw s7,(s6)	  	;Sprite Count
		
		sw zero,(s6)	;Store in buffer
		addi s6,s6,4
		
nativespr_drawarrayb_hide:
		
		beq s7,zero,NativeSpr_ClearUnused	;All done?
		nop
		
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s7,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s6,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s5,0(sp)			;Put the register onto the stack
		
			jal nativespr_drawone	;Remove this sprite
			nop
		
		lw s5,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointe
		lw s6,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer	
		lw s7,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
	
			li s1,3			;12 bytes per entry
			
nativespr_drawarrayb_hideClearAgain:		
			sw zero,(s6)		;Clear this entry
			addi s6,s6,4
			
			addi s1,s1,-1
			bne s1,zero,nativespr_drawarrayb_hideClearAgain	
			nop
			
		addi s7,s7,-1
			
		j nativespr_drawarrayb_hide
		nop
		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nativespr_testoneRK:
	li s2,4			;byte count
nativespr_testoneRKAgain:
	lb s0,(s5)
	lb s1,(s6)
	nop

	bne	s0,s1,nativespr_TestOne_fail
	nop
	
	addi s2,s2,-1
	bne s2,zero,nativespr_testoneRKAgain
	nop
	
	li v1,0				;Clear Carry (unchanged)
	jr ra				;Return
	nop
	
	
nativespr_TestOne_fail:
	li v1,1				;Set Carry (needs Draw)
	jr ra				;Return
	nop


nativespr_testone:
	li s2,3				;Word count
nativespr_testoneB:	
	lw s0,(s5)			;Load a word
	lw s1,(s6)			;Load Comparison
	nop
	bne	s0,s1,nativespr_TestOne_fail	;Jump if no match
	nop
	
	addi s2,s2,-1
	bne s2,zero,nativespr_testoneB		;Test Next Word
	nop
	
	li v1,0				;Clear Carry
	jr ra				;Return
	nop
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NativeSpr_DrawArray:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		la s5,nativespriteactivebuffer
		
		lw s7,(s6)
		addi s6,s6,4	;get Sprite Count (Live array)
		sw s7,(s5)
		addi s5,s5,4	;store Sprite Count (Buffer)
	
NativeSpr_DrawArrayB:
		beq s7,zero,NativeSpr_ClearUnused
		nop
		
		jal nativespr_testone	;See if this sprite has changed
		nop						; Since last draw (compare to buffer)
		
		beq v1,zero,nativespr_nochange
			
		addi sp,sp,-12		;Subtract from Stack pointer
		sw s7,0(sp)			;Put the register onto the stack
		sw s6,4(sp)			;Put the register onto the stack
		sw s5,8(sp)			;Put the register onto the stack
		
			addi sp,sp,-4		;Subtract 4 from Stack pointer
			sw s6,0(sp)			;Put the register onto the stack
			
				move s6,s5
				jal nativespr_drawone  	;Remove cached sprite
				nop
			
			lw s6,0(sp)		;Pop the register off the stack
			addi sp,sp,4	;Add 4 to the Stack pointer

			jal nativespr_drawone		;Draw new sprite
			nop
		
		lw s5,0(sp)		;Pop the register off the stack
		lw s6,4(sp)		;Pop the register off the stack
		lw s7,8(sp)		;Pop the register off the stack
		addi sp,sp,12	;Add to the Stack pointer
				
nativespr_nochange:		
		li s1,3
nativespr_Transfer:
		lw s0,(s6)		;Copy 4 bytes
		addi s6,s6,4
		
		sw s0,(s5)
		addi s5,s5,4
		
		addi s1,s1,-1
		bne s1,zero,nativespr_Transfer
		nop
		
		addi s7,s6,-1
		j NativeSpr_DrawArrayB
		nop

NativeSpr_ClearUnused:
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
nativespr_drawone:		
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		lw s1,(s6)		;Xpos 
		addi s6,s6,4
		
		lw s4,(s6)		;Ypos 
		addi s6,s6,4
		
		lw s5,(s6)		;NativeSpriteDef 
		addi s6,s6,4
		
		or s0,s4,s1
		beq s0,zero,nativespr_drawone_SpriteEmpty
		nop
			
		jal nativespr_drawextra
		nop
			
nativespr_drawone_SpriteEmpty:	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nativespr_drawoneRK:		
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
	
		lbu s4,(s6)			;Ypos 
		addi s6,s6,1
		
		lbu s1,(s6)			;Xpos 
		addi s6,s6,1
		
		lbu s0,(s6)			;NativeSpriteDef L
		addi s6,s6,1
		
		lbu s5,(s6)			;NativeSpriteDef H
		addi s6,s6,1
		
		sll s5,s5,8	
		add s5,s0,s5		;Build up Little endian address
			
		or t0,s4,s1
		beq t0,zero,nativespr_drawone_SpriteEmptyRK	
		nop
		
		move s6,s5
		jal AddressRemapViaTableR6	
		nop		
		move s5,s6
		
		jal nativespr_drawextra
		nop
		
nativespr_drawone_SpriteEmptyRK:
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
		
	