	.align 4
MaxTileClearBorder:
	
	
	li a0,0b00000111111111100000011111111110 ; ;13  %RRRRRGGGGGBBBBB-
	
	la s5,AdrScreenBase
	lw s5,(s5)
	
;Left
	la t6,MaxTileClearBorder_Vert
	move s6,s5
	jalr t6,t3
	nop
	
;Right
	addi s6,s5,512-12
	jalr t6,t3
	nop
	

;Top
	la t6,MaxTileClearBorder_Horiz
	move s6,s5
	jalr t6,t3
	nop
		
;Bottom
	la t6,MaxTileClearBorder_Horiz
	move s6,s5
	li t0,640*186
	add s6,s5,t0
	jalr t6,t3
	nop
		
	
	
	jr ra				;Return
	nop
	
	
	
	
MaxTileClearBorder_Horiz:	
	li t1,6
MaxTileClearBorder_HorizAgainY:	
	
	li t0,256/8
MaxTileClearBorder_HorizAgainX:		
	sw a0,0(s6)
	sw a0,4(s6)
	sw a0,8(s6)
	sw a0,12(s6)
	
	addi s6,s6,16
	
	addi t0,t0,-1
	bne t0,zero,MaxTileClearBorder_HorizAgainX
	nop
	
	addi s6,s6,640-512
	
	addi t1,t1,-1
	bne t1,zero,MaxTileClearBorder_HorizAgainY
	nop
	
	jr t3				;Return
	nop
	
	
MaxTileClearBorder_Vert:	
	li t0,192

MaxTileClearBorder_VertAgain:		
	sw a0,0(s6)
	sw a0,4(s6)
	sw a0,8(s6)
	
	
	addi s6,s6,640
	
	addi t0,t0,-1
	bne t0,zero,MaxTileClearBorder_VertAgain
	nop
	
	jr t3				;Return
	nop
	
	
InitMaxTile:
	jr ra				;Return
	nop
	
	

MaxTileGetScreenPos: ; d1=x d4=y (in pairs of pixels)
	andi s1,s1,0xFF
	andi s4,s4,0xFF

	la s6,AdrScreenBase
	lw s6,(s6)

	sll t0,s1,4		;2 bytes per pixel (Xpos)
	
	move t0,s4			;Ypos
	li t1,320*2			;Bytes per line+Char
	multu t1,t0
		
	mflo t1
	add s6,s6,t1	
		
	jr ra				;Return
	nop
	
	
;r5=Tilemap r4=TileOffset r6=Vram dest
			
drawtile:
	;btst #0,d0
	andi t0,s0,0b00000001
	;.ifndef tiletest_basiconly		;for minimal testing
		bne t0,zero,drawtileadvanced
		nop
;	.endif
	sll s0,s0,1
	;asl.b #1,d0				;%NNNNXYP0 ... Update flag cleared (bit 0)
	sb s0,(s5)
	addi s5,s5,1
	;move.b d0,(a2)+
	
	
drawtilebasiconly:
	andi s0,s0,0b11110000
	;and.b #%11110000,d0		;%nnnn----
	
	lbu a0,(s5)
	addi s5,s5,1
	sll a0,a0,8
	or s0,s0,a0
	
	sll s0,s0, 3			;128 bytes per tile
	add s1,s0,s4				;NNNNNNNN nnnn----
	
	
	;clr.l D2
	;move.b d0,D2
	;clr.l d0
	;move.b (a2)+,d0			;%NNNNNNNN
		
	;asl.l #8,d0
	;or.w d0,D2				;NNNNNNNN nnnn----
	
	li s2,8

	move s3,s6
drawtilebasiconly_NextLine:	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	li t0,640-16
	
	add s6,s6,t0
	
	addi s2,s2,-1
	bne s2,zero,drawtilebasiconly_NextLine
	nop
	
	move s6,s3
	
	j tiledone
	nop
	
	
	
	

drawtileadvanced:

	andi s0,s0,0b00000110		;%-NNNNXYP
	beq s0,zero,drawtilecustom		;X,Y flip 0 = special prog
	nop
	
	lbu s0,(s5)
	nop
	andi s0,s0,0b11111110
	sb s0,(s5)
	
	
	;.ifdef tiletest_noflip	;for minimal testing
	;	j drawtilebasiconly
	;	nop
	;.endif
	
	andi s0,s0,0b11110000
	
	lbu a0,1(s5)
	nop
	sll a0,a0,8
	
	or s0,s0,a0
	
	sll s0,s0,3				;128 bytes per tile
	add s1,s0,s4				;NNNNNNNN nnnn----
	
	
	lb s0,(s5)
	addi s5,s5,2
	
	
	li s2,8				;Linecount
	move s3,s6
	
	andi t0,s0,0b00000100
	bne t0,zero,drawtileyflip
	nop
	
	
	
	addi s6,s6,14
	
drawtileXflip_NextLine:	
	lhu s0,(s1)		;1 pixel
	
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,2
	sh s0,(s6)
	addi s6,s6,-2
	
	
	li t0,640+16
	
	add s6,s6,t0
	
	
	addi s2,s2,-1
	bne s2,zero,drawtileXflip_NextLine
	nop
	
	move s6,s3
	j tiledone
	nop

drawtileyflip:
	
	
	li s2,8
	
	andi t0,s0,0b00001000
	bne t0,zero,drawtilexyflip
	nop
	
	
	addi s1,s1,16*7
	
	move s3,s6
drawtileYflip_NextLine:	
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	addi s6,s6,4
	
	addi s1,-32
	
	li t0,640-16
	add s6,s6,t0
	
	
	addi s2,s2,-1
	bne s2,zero,drawtileYflip_NextLine
	nop
	
	move s6,s3
	j tiledone
	nop
	
drawtileXYflip:	

	addi s1,s1,126

	move s3,s6
drawtileXYflip_NextLine:
	lhu s0,(s1)		;1 pixel
	
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	lhu s0,(s1)		;1 pixel
	addi s1,s1,-2
	sh s0,(s6)
	addi s6,s6,2
	
	
	
	li t0,640-16
	add s6,s6,t0
	
	addi s2,s2,-1
	bne s2,zero,drawtileXYflip_NextLine
	nop
	
	move s6,s3
	j tiledone
	nop
	

	
drawtileempty:
	lbu s0,-1(s5)	;255=empty <255=tilenum
	
	li t0,255
	bne t0,s0,drawtiletransp
	nop
	j tiledone
	nop
	
drawtiletransp:		;;;;;;;;;;;;;;;;;;transparent

	sll s1,s1,7
	add s1,s1,s4
	
	li s2,8		;H
		
	li t0,0xFFFEFFFE	;Ensure bottom (unused) bit is ignored	
		
	move s3,s6
	
drawtileTransp_NextLine:	
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	and s0,s0,t0
	beq s0,zero,drawtileTransp_skip1
	nop
	sw s0,(s6)
drawtileTransp_skip1:
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	and s0,s0,t0
	beq s0,zero,drawtileTransp_skip2
	nop
	sw s0,(s6)
drawtileTransp_skip2:
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	and s0,s0,t0
	
	beq s0,zero,drawtileTransp_skip3
	nop
	sw s0,(s6)
drawtileTransp_skip3:
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	and s0,s0,t0
	
	beq s0,zero,drawtileTransp_skip4
	nop
	sw s0,(s6)
drawtileTransp_skip4:
	addi s6,s6,4
	
	li t1,640-16
	add s6,s6,t1
	
	addi s2,s2,-1
	bne s2,zero,drawtileTransp_NextLine
	nop
	move s6,s3
	
	j tiledone
	nop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustom:
	
	
	lbu s0,(s5)
	nop
	andi s0,s0,0b11111110	;NN------
	sb s0,(s5)

	;move.b (a2),d0			
	;and.b #%11111110,d0
	;move.b d0,(a2)
	
	sll s0,s0,2
	li t0,0b0000001100000000
	and s1,s0,t0
	lbu s0,1(s5)
	nop
	or s1,s1,s0
	
	;lsl.l #2,d0
	;and.l #%0000001100000000,d0
	;move.l d0,D2

	lbu s0,(s5)
	
	addi s5,s5,2
	
	andi s0,s0,0b00110000	;cmd bits
	beq s0,zero,drawtilefill
	nop
	
	li t0,0b00110000
	beq s0,t0,drawtileempty
	nop
	
drawtiledouble:		
	sll s1,s1,6		;pattern *64
	add s1,s1,s4

	li s2,4
	
	move s3,s6
drawtiledoubleAgain:		
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	sw s0,640(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	sw s0,640(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	sw s0,640(s6)
	addi s6,s6,4
	
	lw s0,(s1)		;2 pixels
	addi s1,s1,4
	sw s0,(s6)
	sw s0,640(s6)
	addi s6,s6,4
	
	
	li t0,1280-16
	add s6,s6,t0
	
	addi s2,s2,-1
	bne s2,zero,drawtiledoubleAgain
	nop
	
	move s6,s3
	
	j tiledone
	nop

drawtilefill:
	la s0,N64_MaxTile_SolidFills
	sll s1,2
	add s1,s1,s0
	lhu t0,(s1)
	sll s0,t0,16
	or s0,s0,t0		;2 pixels

	li s1,8
	move s3,s6
	
drawtileFill_NextLine:	
	sw s0,(s6)
	sw s0,4(s6)
	sw s0,8(s6)
	sw s0,12(s6)
	
	li t0,640
	add s6,s6,t0
	
	
	addi s1,s1,-1
	bne s1,zero,drawtileFill_NextLine
	nop
	
	move s6,s3
	
	j tiledone	
	nop

